#!/usr/bin/ruby

$hpformat = '%-11.10s'

class HRecord < Hash
  include Comparable
  
  def method_missing(var, *args)
    if var =~ /^(\w+)=$/
      if self.include?($1.to_s)
        self.set($1.to_s, args[0])
      else
        self.set($1.to_sym, args[0])
      end
      return self
    else
      return self.value(var.to_sym) || self.value(var.to_s)
    end
  end

  def initialize(fieldValue, fieldName = :key)
    self.setValue(fieldValue, fieldName)
  end

  def setValue(fieldValue, fieldName = :key)
    self[fieldName] = fieldValue
    return self
  end

  def set(fieldName, fieldValue)
    self.setValue(fieldValue, fieldName)
    return self
  end

  def value(fieldName = :key)
    puts "hrecord::value: it's exist #{fieldName} symbol and string - #{self}".red if self[fieldName.to_sym] and  self[fieldName.to_s]
    return self[fieldName.to_sym] || self[fieldName.to_s]
  end

  def <=>(record)
     self[:key] <=> record[:key]
  end  

  def to_f(fieldName = :key)
    return self[fieldName].to_f()
  end  
  
  def show(key = :key)

    color = self.include?(:color) ? self[:color] : "white"
    value = $hpformat % self.value().to_s()
    eval("print value.#{color}")

  end

  def showAll(key = :key)

    self.each do |key, value|
      puts "#{key}: #{value}"
    end
    puts "=" * 20

  end

  def self.test()
    rec = HRecord.new("a")
    rec.setValue("0", "index-0")
    rec.set("index-1", "1")
    rec.show() 
    puts rec == rec
  end

end

#HRecord.test
