#!/usr/bin/ruby
require 'hdb/hdbi.rb' 

class HDBI

  def self.testx
    resultTable = hdb.select([:id, :name]).from(:recipe_types).where(["id > 0", "id < 20000"]).orderBy([:id, :name]).execute
    resultTable.show
  end
  
  def self.testxx
    resultTable = hdb("quickorder_pg").select([:id, :name]).from(:recipe_types).where(["id > 0", "id < 20000"]).orderBy([:id, :name]).execute
    resultTable.show
  end

  def self.testmysql
    id = hdb("quickorder").insert(:city_table, {name: "Wien"})
    puts "id: #{id}"
    resultTable = hdb("quickorder").select([:id, :name]).from(:city_table).where(["id > 0", "id < 20"]).orderBy([:id, :name]).execute
    resultTable.show
  end

  def self.test
  end


  def self.test0

    hdb = HDB.new('localhost', '5432', 'quickorder', 'quickorder', 'quickorder')
    hdb.openConnection()
    resultTable = hdb.select([:id, :name]).from(:cookbook).where(["id > 0", "id < 200"]).orderBy([:id, :name]).execute
    resultTable = hdb.select("id, name").from("cookbook").where("id > 0 and id < 200").execute
    hdb.show()
    resultTable = hdb.select([:id, :name]).from(:cookbook).where(["id > 0", "id < 200"], "or").orderBy([:id, :name]).execute(pageSize: 10, page: 2)
    hdb.toSqlTable().show()
    id = hdb.insert(:recipe_types, {name: "'nome"})
    p "delete: " + hdb.delete(:recipe_types, {id: id, name: '10'}).to_s
    hdb.select(:name).from(:recipe_types).execute
    hdb.show()
    hdb.closeConnection

  end


  def self.test1

    dbh = DBI.connect("dbi:Pg:quickorder:localhost", "quickorder", "quickorder")
    sth = dbh.execute("select * from cookbook")
    p sth.column_names
    sth.fetch do |row|
      #p row['name'] # or row.by_field("name")
      #p row[3]      # or row.by_index(3)
      row.each_with_name do |fieldValue, fieldName|
        p "  #{fieldName}: #{fieldValue}"
      end
      p "======================="
    end
    sth.finish

  end

  def self.test2

    dbh = DBI.connect("dbi:Pg:quickorder:localhost", "quickorder", "quickorder")
    sth = dbh.prepare("select * from cookbook where id = ?")
    sth.execute(1)
    p sth.column_names
    sth.fetch do |row|
      #p row['name'] # or row.by_field("name")
      #p row[3]      # or row.by_index(3)
      row.each_with_name do |fieldValue, fieldName|
        p "  #{fieldName}: #{fieldValue}"
      end
      p "======================="
    end
    sth.finish

  end


  # finish isn't required
  def self.test3

    dbh = DBI.connect("dbi:Pg:quickorder:localhost", "quickorder", "quickorder")
    rows = dbh.select_all("select * from cookbook") # con select_all o select_one non e' necessario finish
    rows.each do |row|
      row.each_with_name do |fieldValue, fieldName|
        p "  #{fieldName}: #{fieldValue}"
      end
      p "======================="
    end

  end


  def self.test4

    dbh = DBI.connect("dbi:Pg:quickorder:localhost", "quickorder", "quickorder")
    dbh.do("insert into recipe_types(name, position, department) values(?, ?, ?)", 'hypersonic', 1, nil)

  end

  def self.test5

    dbh = DBI.connect("dbi:Pg:quickorder:localhost", "quickorder", "quickorder")
    sth = dbh.prepare("insert into recipe_types(name, position, department) values(?, ?, ?)")
    sth.execute('hypersonic', 1, nil)
    sth.finish

  end

  def self.test6

    dbh = DBI.connect("dbi:Pg:quickorder:localhost", "quickorder", "quickorder")
    sth = dbh.execute("select * from cookbook")
    rows = sth.fetch_all

    printf "Number of rows affected: %d\n", sth.rows
    printf "Number of columns: %d\n", sth.column_names.size

    rows.each do |row|
      row.each_with_name do |fieldValue, fieldName|
        p "  #{fieldName}: #{fieldValue}"
      end
      p "======================="
    end
    sth.finish

  end

end


