#!/usr/bin/ruby

require 'mysql'
require 'hdb/hdb'

class Hash

  def join(separator)

    arr = []
    self.each do |key, value|
      arr << "#{key} = #{value}"
    end
    return arr.join(separator)

  end
end

class Array

  def hjoin(separator, quoteChar = '"')

    arr = []
    self.each { |value| arr << "#{value}" }
    return arr.join(separator)
  end

end

class HMySql < HDB
  
  def initialize(host, port, dbname, user, password, timezone, connectionName)

    super(host, port, dbname, user, password, timezone, connectionName, "hmysql")
    @result = nil

  end

  def connect()

    @connection = Mysql.new(@host, @user, @password, @dbname, @port.to_i)
    #hl << "Server version: #{self.execute("SHOW server_version").dataByFieldIndex(0,0).to_s}"
    self.execute("SET time_zone = '#{@timezone}'") if @timezone
    return @connection

  end

  def disconnect()

    @connection.close()
    @connection = nil

  end

  def _execute(queryStr = self.queryStr) 

    @result = @connection.query(queryStr)
    
    return self unless @result
    
    @resultTable = HFieldTable.new()
    self.fieldNameList().each { |fieldName| @resultTable.addFieldName(fieldName) }
    @resultTable.makeCaption()
    r = 0
    @result.each do |row|  
      row.each_with_index do |fieldValue, c|
        @resultTable.setDataByFieldIndex(r, c, fieldValue.to_s)
      end
      r += 1
    end

    return self

  end
  
  def fieldNameList()

    fieldList = HList.new()
    
    @result.fetch_fields.each { |field| fieldList << field.name }
    
    return fieldList

  end
  
  def insert(tableName, values)

    self.execute("INSERT INTO #{tableName} #{self.insertValues(values)}")
    return @connection.insert_id

  end

  def rowsAffected
    return @connection.affected_rows()
  end


end

