#!/usr/bin/ruby

require 'mysql2'
require 'hdb/hdb'

class Hash

  def join(separator)

    arr = []
    self.each do |key, value|
      arr << "#{key} = #{value}"
    end
    return arr.join(separator)

  end
end

class Array

  def hjoin(separator, quoteChar = '"')

    arr = []
    self.each { |value| arr << "#{value}" }
    return arr.join(separator)
  end

end

class HMySql2 < HDB
  
  def initialize(host, port, dbname, user, password, timezone)

    super(host, port, dbname, user, password, timezone, "hmysql2")
    @result = nil

  end

  def connect()

    @connection = Mysql2::Client.new(host: @host, username: @user, password: @password, database: @dbname, port: @port.to_i)
    #hl << "Server version: #{self.execute("SHOW server_version").dataByFieldIndex(0,0).to_s}"
    self.execute("SET time_zone = '#{@timezone}'") if @timezone
    return @connection

  end

  def disconnect()

    @connection.close()
    @connection = nil

  end

  def _execute(queryStr = self.queryStr) 

    @result = @connection.query(queryStr)
    
    return self unless @result
    
    @resultTable = HFieldTable.new()
    self.fieldNameList().each { |fieldName| @resultTable.addFieldName(fieldName) }
    @resultTable.makeCaption()
    @result.each_with_index do |row, i|  
      row.each do |fieldName, fieldValue|
        @resultTable.setDataByFieldName(i, fieldName, fieldValue.to_s)
      end
    end

    return self

  end
  
  def fieldNameList()

    fieldList = HList.new()
    
    @result.fields.each { |fieldName| fieldList << fieldName }
    
    return fieldList

  end
 
  def rowsAffected
    return @connection.affected_rows()
  end

  def insert(tableName, values)

    self.execute("INSERT INTO #{tableName} #{self.insertValues(values)}")
    return @connection.last_id

  end

end

