require 'hdb/hdb'

class HPgSql < HDB
  
  def initialize(host, port, dbname, user, password, timezone, connectionName)

    super(host, port, dbname, user, password, timezone, connectionName, "hpgsql")
    @result = nil

  end

  def connect()

    @connection = PGconn.new(@host, @port, "", "", @dbname, @user, @password)
    hl << "Server version: #{self.execute("SHOW server_version").firstData.to_s}"
    self.execute("SET TIME ZONE '#{@timezone}'") if @timezone
    return @connection

  end

  def disconnect()

    @connection.close()
    @connection = nil

  end

  def _execute(queryStr = self.queryStr) 

    @table = []
    @result = @connection.query(queryStr)
    @result.each do |row|  
      @table << row
    end
    return self

  end
  
  def fieldNameList()

    fieldList = {}
    
    @result.fields.each { |fieldName| fieldList[fieldName] = nil }
    
    return fieldList

  end

  def rowsAffected
    return @result.cmd_tuples()
  end

end

