require 'date'

class HLogger

  # log on screen if filename is stdout
  HLOG_MAXSIZE = 10 # 10MB
  def initialize(filename, level: 'DEBUG')
    @levels = self._levels 
    @levelToNum = self._toNum
    @level = @levelToNum[level]
    return if(filename == "stdout")
    filename = "logger.txt" if(filename == nil)
    if (File.exist?(filename) and File.size(filename).to_f / 1000000 >= HLOG_MAXSIZE)
      timestamp = DateTime.now.strftime "%d-%m-%Y-%H.%M.%S"
      File.rename(filename, "#{filename}.#{timestamp}")
    end
    @file = File.new(filename, "a+")
  end

  def _levels
    levels = []
    levels << "OFF"
    levels << "FATAL"
    levels << "ERROR"
    levels << "WARNING"
    levels << "INFO"
    levels << "DEBUG"
    levels << "DEBUG2"
    levels << "DEBUG3"
    levels << "DEBUG4"
    levels << "ALL"

    return levels
  end

  def _toNum

    levelToNum = {}
    self._levels.each_with_index do |level, i|
      levelToNum[level] = i
    end
    
    return levelToNum

  end

  def toNum(strLevel)
    return @levelToNum[strLevel]
  end

  def level(value)
    
    return @levels[value]

  end

  def close
    @file.close if(@file)
  end

  def timestamp
    return DateTime.now.strftime "%d-%m-%Y %H:%M:%S"
  end

  # hlogger << "hello world"
  # hlogger.<<("hello world", "DEBUG") # warning: if i put some space doesn't work

  def << (str, level = 'DEBUG')

    level = self.toNum(level) if(level.class == String)
  
    return if(level > @level)

    t = self.timestamp
    strLevel = self.level(level)
    if(@file)
      @file << "[#{strLevel} #{t}]$ #{str}\n"
    else
      case self.level(level)
      when "ERROR"
        puts "[#{strLevel} hypersonic]$ #{str}".red 
      when "FATAL"
        puts "[#{strLevel} hypersonic]$ #{str}".red 
      when "DEBUG"
        puts "[#{strLevel} hypersonic]$ #{str}".green 
      when "WARNING"
        puts "[#{strLevel} hypersonic]$ #{str}".hight_cyan
      when "INFO"
        puts "[#{strLevel} hypersonic]$ #{str}".hight_purple 
      else
        puts "[#{strLevel} hypersonic]$ #{str}".white
      end
    end
  
    return self

  end

  # You can use this function more beautiful than .<<(...)
  
  def write(str, level)
    self.<<(str, level)
  end

end



def hlogger

  return hsd.value("hlogger")

end

def hl 

  return hlogger

end
