#!/usr/bin/ruby

require "singleton"

class HSessionData

  include Singleton 

  def initialize()

    @databaseManager = hpgsql()

  end

  def session()
    return hsd().value(:session)
  end

  def sessionId()
    return (self.session()[:sessionId]) ? self.session()[:sessionId] : -1
  end

  def setValues(params)

    sessionId = self.sessionId
    self.session[:sessionId] = sessionId = @databaseManager.insertOrUpdateIfExist("session_table", "id = #{sessionId}", {:value => params})

    i = 0
    session_record = Hash.new()
    params.each do |key, value|
      session_record = {:session_id => sessionId,
                    :field_name => key,
                    :field_value => value,
                    :ordering => i}
      session_recordWhere = "session_id = #{sessionId} and field_name = '#{key}'"
      @databaseManager.insertOrUpdateIfExist("session_record_table", session_recordWhere, session_record)
      i += 1

      # se trova username tra i parametri lo memorizza singolarmente 
      # in modo da essere usato piu' facilmente dalle altre funzioni
      username = @databaseManager.parentChildValueOf("session", "session_record", sessionId, key, "username")
      self.setValues({:username => username}) if (username)

    end

  end

  def valueOf(fieldName, key = nil)

    return @databaseManager.parentChildValueOf("session", "session_record", self.sessionId, fieldName, key)

  end
 

  def value1()

    sessionId = self.sessionId
    return nil if(sessionId == -1)
    
    selectQuery = "select value from session_table where id = #{sessionId}"
    tableResult = @databaseManager.run(selectQuery).result
    return nil if(tableResult.count == 0)
    return eval(tableResult[0]["value"])

  end

  def self.test1()

  end


end


def hsession()

    return HSessionData.instance()

end
