class HAccordionMenu < HDivTag
  
  attr_reader :mainView

  def initialize(items: [], id: nil, mainView: nil)
    super(class: "haccordion-menu")
    self.set(id: id) if id
    #self.appendChild(HWidget.new("style", "##{id}:target { display: block; }", scoped: nil));
    @items = items
    @mainView = mainView
  end

  def addItem(value)
    @items << value
    return self
  end

  def a(innerHTML = '', icon: nil, **args)

    a = HWidget.new("a", "", args)
    a << HWidget.new('span', class: icon) if icon
    a << HWidget.new('span', innerHTML)
    return a

  end

  def onClick(moduleName: nil, modelName: nil)
    hl << "HAccordionMenu.onClick (#{moduleName} - #{modelName})".red
    return @mainView.html(moduleName: moduleName, modelName: modelName)
  end


  def appendChildren(parent, items)

    items.each do |value|
      if(value[:type] == 'link')
        ref =  eval(value[:ref]) if value[:ref]
        parent << link = (self.a(value[:name], icon: value[:icon]))
        link.connect(:onclick, self, "onClick", id: @mainView.oid, args: ref)
      elsif(value[:type].include? 'section' )
        parent.appendChild( HDivTag.new(value[:name], class: "#{value[:type]}-name") )
        sectionContentDiv = HDivTag.new(class: "#{value[:type]}-content")
        parent.appendChild(sectionContentDiv)
        self.appendChildren(sectionContentDiv, value[:content])
      end
    end

  end


  def html()
    self.appendChildren(self, @items)
    return super
  end

  def self.test1()

    subSection = [
      {type: 'section', name: 'Section-A', content:[
        {type: 'link', name: 'Section-a1', href:'#'},
        {type: 'link', name: 'Section-a2', href:'#'},
        {type: 'link', name: 'Section-a3', href:'#'}
      ]
      },

      {type: 'section', name: 'Section-B', content:[
        {type: 'link', name: 'Section-b1', href:'#'},
        {type: 'link', name: 'Section-b2', href:'#'},
        {type: 'link', name: 'Section-b3', href:'#'}
      ]
      },
    ]

    openSection = [{type: 'link', name: 'O-Section1', href:'#', icon: 'glyphicon glyphicon-user'},
                   {type: 'link', name: 'O-Section2', href:'#'},
                   {type: 'link', name: 'O-Section3', href:'#'}
    ]

    items = [
      {type: 'section', name: 'Section-A', content:[
        {type: 'link', name: 'Section-a1', href:'#'},
        {type: 'link', name: 'Section-a2', href:'#'},
        {type: 'link', name: 'Section-a3', href:'#'}
      ]
      },

      {type: 'section', name: 'Section-B', content: subSection},
      {type: 'open-section', name: 'Open Section', content: openSection},
    ]
    return HAccordionMenu.new(items).html()

  end

  def self.appendChild1(parent, root = [])
    parent.children.each do |item|
      next if item.name == "text"
      menuItem = item.to_h.symbolize_keys
      if item.name == "menusection"
        menuItem[:type] = "section" unless menuItem[:type]
        menuItem[:content] = self.appendChild1(item) 
      elsif item.name == "menuitem"
        menuItem[:type] = "link"
      end
      root << menuItem
    end
    return root 

  end

  def self.loadMenuByModuleName(moduleName: nil, mainView: nil)
    menuView = hv().viewByFileName(moduleName, "app/modules/#{moduleName}/menu_view.xml")
    items = self.appendChild1(menuView.hypersonic)
    return HAccordionMenu.new(items: items, id: moduleName, mainView: mainView).html()
  end


end
