#!/usr/bin/env ruby

require "hwidgets/hgrouptag"

class HCheckBoxTag < HGroupTag

    attr_accessor :checked

    def initialize(name = nil, modelName = nil, placeholder = nil)
      super(name, modelName, placeholder)
      @checkBox = nil
    end

    def html()
      for i in (0..@items.count - 1) do
        item = @items[i]
        value = @values[i]
        id = "#{@modelName}_#{@name}_#{value.downcase()}"
        name = "#{@modelName}[#{@name}][#{value}]"
        hiddenCheckBox = HInputTag.new(@name, @modelName, nil, nil, type = "hidden").set(name: name, value: "0")
        checkBox = HInputTag.new(@name, @modelName, value, nil, type = "checkbox") if (@checkBox == nil)
        checkBox.placeholder = item
        checkBox.set(checked: "") if (@selectedItem[value.to_s] == "1")
        checkBox.set(name: name, value: "1", id: id)
        checkBox.setReverse()
        self << checkBox << hiddenCheckBox
      end

      return super()
    
    end

end
