class HDropDown < HDivTag

  def initialize(sourceView: nil, caption: "select", items: [], **args)

    @sourceView = sourceView
    @caption = caption 
    @items = items

    return super(class: 'hdropdown', **args)
  end

  def button
    return HWidget.new("button", @caption, class: "dropbtn") 
  end
    
  def a(innerHTML = '', icon: nil, **args)

    a = HWidget.new("a", "", args)
    a << HWidget.new('span', class: icon) if icon
    a << HWidget.new('span', innerHTML)
    return a

  end

  def content
    contentDiv = HDivTag.new(class: 'dropdown-content')
    @items.each do |item|
      action = item.delete(:action)
      link = self.a(item.delete(:name), icon: item.delete(:icon), **item)
      link.connect(:onclick, @sourceView, "rpcAction", args: {action: action}, 
                   id: @sourceView.oid, mode: 'none',
                   attributes: ":hdbTableView.ids(obj) => ids")

      contentDiv << link
    end
    return contentDiv
  end

  def html
    self << self.button << self.content
    return super
  end 

end
