#!/usr/bin/env ruby

require "hwidgets/hwidget"

class HGroupTag < HWidget

    attr_accessor :items, :values

    def initialize(name = nil, modelName = nil, placeholder = nil, items: nil, values: nil, itemsAndValues: nil, **args)
      super(args)
      @name = name
      @modelName = modelName
      @items = []
      @values = []
      @selectedItem = nil
      @placeholder = placeholder
      @label = nil
      @carriageReturn = false
      self.setItems(items) if items
      self.setValues(values) if values
      self.setItemsAndValues(itemsAndValues) if itemsAndValues

    end

    def setCarriageReturn(value = true)
      @carriageReturn = value
      return self
    end

    def setItemsAndValues(itemsAndValues)
     
       @items = itemsAndValues.keys
       @values = itemsAndValues.values

    end

    def setItems(items)

      @items = items
      return self

    end

    def setValues(values)

      @values = values
      return self

    end

    def setSelected(item)
    
      @selectedItem = item
      return self

    end

    def html()

      @label = HLabelTag.new(@name, @modelName, @placeholder).setCarriageReturn(@carriageReturn) if (@label == nil)
      return @label.html() + super()
    
    end

end
