#!/usr/bin/env ruby

require "hwidgets/hlabeltag"

class HInputTag < HWidget

    attr_accessor :name, :modelName, :placeholder, :label, :type, :reverse

    def initialize(name = "", modelName = "", placeholder = "", label = nil, type = nil)
      super("input")
      self.setClosedTag(false)
      @name = name
      @modelName = modelName
      @placeholder = placeholder
      @label = label
      @type = type
      @carriageReturn = false
      @reverse = false
    end

    def self.init(name: "", modelName: "", placeholder: "", label: nil, type: nil)

      return HInputTag.new(name, modelName, placeholder, label, type)  

    end

    def setCarriageReturn(value = true)
      @carriageReturn = value
      return self
    end

    def setReverse(value = true)
      @reverse = value
      return self
    end
    
    def setSelected(value)
      set(value: value) 
    end

    def html()

      self.set(name: "#{@modelName}[#{@name}]",
               id: "#{@modelName}_#{@name}",
               type: @type, 
               placeholder: @placeholder)
      
      @label = HLabelTag.new(@name, @modelName, @placeholder).setCarriageReturn(@carriageReturn) if (@label == nil)
      return @label.html() + super() unless(@reverse)
      return super + @label.html()

    
    end

end
