class HMainView < HDivTag

  attr_reader :oid

  def initialize(**args)
    @view = nil
    @oid = hm().malloc(self).obj.object_id.to_s
    super(class: 'hmainview', id: @oid, **args)
    self.hotLog("HMainView: new hmainview oid: #{@oid}".white)
    return self
  end
  
  def onExit
    hm().dealloc(@oid) if @view
    self.hotLog("HMainView::onExit dealloc hmainview oid: #{@oid}".yellow)
    hl.<< "################################################################################################".hight_cyan, "DEBUG2"
    hl.<< "#                                          [onExit]#:                                          #".hight_cyan, "DEBUG2"
    hm().showAll
  end

  def html(moduleName: nil, modelName: nil)
    self.reset()
    ooid = @view.oid if @view# old oid 
    
    if moduleName and modelName
      self << @view = HDBView.new(moduleName: moduleName, modelName: modelName, poid: @oid)
      self.connect(:honexit, self, "onExit", mode: 'none', id: @view.oid, overwrite: true)
    end 
    
    hm().dealloc(ooid) if ooid
    self.hotLog("HMainView::dealloc hdbview oid: #{ooid}".red) if ooid
    hm().clean()
    
    return super()
  end 

end
