class HPagination < HDivTag

  def initialize(sourceView: nil, pages: 1, currentPage: 0, pageSize: 'all', rowsForPage: [10, 100, 'all'] , **args)
    @sourceView = sourceView # l'oggetto da paginare
    @pageSize = pageSize
    @pages = pages
    @currentPage = currentPage
    @rowsForPage = rowsForPage

    return super(class: 'hpaginationview', **args)
  end

  def setCurrentPage(value: 1)
    value = eval(value) - 1
    value = 0 if value < 0
    value = @pages - 1 if value >= @pages
    return @sourceView.html(page: value)
  end

  def setPageSize(value: 'all')
    return @sourceView.html(pageSize: value)
  end


  def pageDiv
    div = HDivTag.new(class: 'page-box', onclick: 'hpaginationView.editMode(this)') 
    div << HWidget.new("span", "Page:")
    div << currentPageDiv = HWidget.new("input", class: 'current-page', type: 'text', value: @currentPage + 1,  
                       onkeypress: "hpaginationView.keyPress(this, event)")
    currentPageDiv.connect(:onblur, self, "setCurrentPage", id: @sourceView.oid, attributes: ":obj.value")
  
    div << HWidget.new("span", "of")
    div << HWidget.new("span", @pages, class: 'total-pages')
    return div
  end

  def comboboxSection
      
    div = HDivTag.new(class: 'paginationview-block') 
    div << HWidget.new("span", "Rows:")
    div << selectDiv = HSelectTag.new("", "", 
                   items: @rowsForPage, values: @rowsForPage, class: "hcombobox")
    selectDiv.connect(:onchange, self, "setPageSize", id: @sourceView.oid, attributes: ":obj.value")
    return div
    
  end
  
  def navigationButtons

    decDiv = HDivTag.new("&#10094;", class: 'paginationview-block')
    decDiv.connect(:onclick, @sourceView, "html", id: @sourceView.oid, 
                   args: {page: [0, @currentPage - 1].max})
    incDiv = HDivTag.new("&#10095;", class: 'paginationview-block')
    incDiv.connect(:onclick, @sourceView, "html", id: @sourceView.oid, 
                   args: {page: [@sourceView.rpcPages() - 1, @currentPage + 1].min})
    return [decDiv, incDiv]

  end

  def html
    self << self.pageDiv << self.comboboxSection << self.navigationButtons
    return super
  end 

end
