#!/usr/bin/env ruby

require "hwidgets/hgrouptag"

class HRadioButtonTag < HGroupTag

    attr_accessor :radioButton

    def initialize(name = nil, modelName = nil, placeholder = nil)
      super(name, modelName, placeholder)
      @radioButton = nil
    end

    def html()
      for i in (0..@items.count - 1) do
        item = @items[i]
        value = @values[i]
        id = "#{@modelName}_#{@name}_#{item.downcase.gsub(' ', '_')}"
        radioButton = HInputTag.new(@name, @modelName, item, nil, type = "radio") if (@radioButton == nil)
        radioButton.set("checked", "") if (value.to_s == @selectedItem.to_s)
        radioButton.set(value: value, id: id)
        radioButton.setReverse()
        self << radioButton
      end

      return super()
    
    end

end
