
class HWidget

    attr_reader :tag

    def setTag(tag)
      @tag = tag
      return self
    end
    
    def setProperties(properties)
      @properties = properties
      return self
    end
    
    def setSystemProperties(systemProperties)
      @systemProperties = systemProperties
      return self
    end
    
    def setPlaceholders(placeholders)
      @placeholders = placeholders
      return self
    end
    
    def setInnerHTML(innerHTML)   
      @innerHTML = innerHTML
      return self
    end
    
    def setParent(parent)   
      @parent = parent
      return self
    end

    def setChilds(childs)   
      @childs = childs
      return self
    end
    
    def getChilds()   
      return @childs
    end
    
    def setStyles(styles)   
      @styles = styles
      return self
    end

    def setEnablePlaceholder(enablePlaceholder = true)   
      @enablePlaceholder = enablePlaceholder
      return self
    end
    
    def setCloseTag(closeTag)   
      @closeTag = closeTag
      return self
    end

    def setSlots(slots)   
      @slots = slots
      return self
    end

    def initialize(tag = nil, innerHTML = "", **args)
      @tag = tag
      @properties = {}
      @systemProperties = {}
      @placeholders = {}
      @innerHTML = innerHTML
      @parent = nil
      @childs = []
      @styles = {}
      @enablePlaceholder = false # va automaticamente a true con setPlaceholder
      @closeTag = true # se false il tag non viene chiuso - serve ad es. per input
      @slots = {}

      self.set(args)

    end
 
    def copyConstructor
      return Marshal.load(Marshal.dump(self))
    end
"""  
    def method_missing(sym, *args)
      if sym =~ /^(\w+)=$/
        self.set($1, args[0])
      else
        return self.get(sym.to_s)
      end
    end
"""    
    # searchType 0: serch only among childs
    # searchType 1: search top down starting from childs

    def getElementBy(property, value, searchType)
     
      result = (self.properties.key?(property) and self.properties[properties] == value) ? [self] : nil
      @childs.each do |child|
        result << child if child.properties.key?(property) and child.properties[property] == value
      end
      @childs.each { |child| result += child.getElementBy(property, value, searchType) } if searchType == 1
      return result

    end

    def appendChilds(widgets)
      widgets.each { |widget| self.appendChild(widget) }
      return self
    end

    def appendChild(widget)
      return self.appendChilds(widget) if widget.class == Array
      widget.setParent(self)
      @childs << widget
      return self
    end
    alias_method :<<, :appendChild

    def unset(property)      
        @properties.delete(property)
    end

    def _set(property, value, overwrite = false)      
      @properties[property] = value if (!@properties.key?(property) || overwrite)
      #@properties.delete(property) unless (value)
      return self
    end

    # set property
    def set(overwrite: false, **properties)
        
      properties.each do |property, value|
        self._set(property, value, overwrite)
      end
      return self

    end

    def buildSignature(function, functionName, *args) 
      
      params = ['this']
      args.each do |arg|
        if(arg.class == Symbol)
          params << arg # se passo un simbolo ad es. event
        else
          params << arg.to_js_format
        end
      end
      return "#{function}#{functionName}(#{params.join(",")})"

    end 


    def addJsFunction(eventName, functionName, *args)      

      function = ""
      if(@properties[eventName])
        function = "#{@properties[eventName]}; "
      end
      
      function = self.buildSignature(function, functionName, *args)
      
      return self.set("#{eventName}": function, overwrite: true) 

    end
    
    def storeSlots  
    
      @slots.each do |key, elem|
        elem.each do |value|
          self.addJsFunction(key, value[:functionName], *value[:args])
        end
      end

    end
    
    # supporta piu' funzioni per lo stesso evento 
    # @slots e' un hash di array di hash
    def _addJsSlot(eventName, functionName, overwrite = false, *args)      

      @slots.delete(eventName) if overwrite
      @slots[eventName] = Array.new() unless(@slots[eventName])
      @slots[eventName] << {functionName: functionName, args: args}
      return self

    end
    
    # addJsSlot is a very powerful function with many options. Example:
    # - def self.myFunction(id) 
    #    return "hello #{id}" 
    # - end
    # 1) addJsSlot(:ondblclick, :null, {}, "#id", "MyClass.myFunction") # the easiest example 
    # 1) addJsSlot(:ondblclick, "id", {}, "#id", "MyClass.myFunction")  
    #    WARNING: the first id is only the parameter passed to myFunction
    #    i can write: addJsSlot(:ondblclick, "name", {}, "#id", "MyClass.myFunction")
    #
    # 2) tr.addJsSlot(:ondblclick, "id", {before: "alert('hello')"}, "#id", "HDBTableView.myFunction")
    # 3) tr.addJsSlot(:ondblclick, "id", {after: "elem.style.color = 'red'; alert('hello')"}, "#id", "HDBTableView.myFunction")
    # - def self.myFunction(values) 
    #    return "hello #{values[:id]} - #{values[:class]}" 
    # - end
    # 4) tr.addJsSlot(:ondblclick, ["id", "class"], {}, "#id", "HDBTableView.myFunction")
    #
    # - def self.myFunction(id, surname) 
    #    return "hello #{id]} - #{surname}" 
    # - end
    # 5) tr.addJsSlot(:ondblclick, "id", {}, "#id", "HDBTableView.myFunction", "Von Karajan")
    #
    # - def self.myFunction(id, values) 
    #    return "hello #{id]} - #{values[:name]} - #{values[:surname]}" 
    # - end
    # 6) tr.addJsSlot(:ondblclick, "id", {}, "#id", "HDBTableView.myFunction", {name: "herbert", surname: "Von Karajan"})
    #
    # - def self.myFunction(id, values, array) 
    #    return "hello #{id} - #{values[:name]} - #{values[:surname]} - #{array}" 
    # - end
    # 7) tr.addJsSlot(:ondblclick, "id", {}, "#id", "HDBTableView.myFunction", {name: "herbert", surname: "Von Karajan"}, [1,2,3,4,5])
    # 8) addJsSlot(:ondblclick, ':obj.value', {}, "#id", "MyClass.myFunction") #  # mettendo i : il codice js sara' => values = eval('obj.value');


    # 1) In this example the element with id = #id is replaced by "hello #{value}"
    #    Warning: if i want replaced the element with name = 'pippo' i must write:
    #    - addJsSlot(:ondblclick, "id", {getElem: "byName"}, "pippo", "MyClass.myFunction") 
    #    - addJsSlot(:ondblclick, "id", {getElem: "byName", mode: "set"}, "pippo", "MyClass.myFunction")
    #    other options are: getElem: byId | byName | body - mode: set | add
    # 2) The same of the previous with alert('hello') at end
    # 3) The same of the previous with the change the color at end

    # id deve essere un oid
    def connect(event, receiver, method, attributes: :null, id: "#id", args: nil, overwrite: false, **options)      
      oid = hm().malloc({receiver: receiver, method: method, args: args}, id).obj.object_id.to_s
      options[:getElem] = "byId" unless options[:getElem]
      options[:mode] = "set" unless options[:mode]

      cks = Digest::SHA256.hexdigest oid + hc.value("secret_token")
      cks += "-" + Time.now.to_i.to_s # serve (forse) in caso di riallocazione dello stesso indirizzo di memoria
      hotLog( "HWidget::connect(id: #{id}, oid: #{oid} - #{options[:hotLog].green}" ) if options[:hotLog]
      return self._addJsSlot(event, :'return hajax.signalManager', overwrite, attributes, options, id, oid, cks)
    end

    def get(property)      
        return @properties[property]
    end

    def replacePlaceholder(str)

      return str unless @enablePlaceholder
      @placeholders.each do |key, value|
        str = str.gsub(key, value.to_s)
      end
   
      return str

    end

    def hotLog(str)
      HHotLogger.append(str, "log4widgets")
    end

    def strProperties() 

      propertiesTmp = Marshal.load(Marshal.dump(@properties))
      self.storeSlots()
      self.storeStyle()
      return "" if @properties.empty?

      result = ""
      @properties.each do |key, value| 
        if(value)
          value = self.replacePlaceholder(value)
          result += "#{key}=\"#{value}\" "
        else
          result += "#{key} "
        end
      end

      @properties = propertiesTmp
      return result

    end

    def openTag()
      
      return "" unless (@tag)

      slash = (@closeTag) ? "" : "/"
      result = self.strProperties()
      return HIO.htmlEcholnOpenBlock("<#{@tag} #{result}#{slash}>")

    end

    def closeTag()
      return "" unless (@tag)
      return (@closeTag) ? HIO.htmlEcholnCloseBlock("</#{@tag}>") : ""
    end

    def reset()
      @parent = nil
      @childs = []
    end

    def html() 
      
      html = @innerHTML
      @childs.each { |child| html += child.html() }
      return self.openTag() + HIO.htmlEcholn(html) + self.closeTag()  

    end
    
    def _setStyle(property, value)
  
      unless (value)
        @styles.delete(property)
        return self
      end
      @styles[property] = value
      return self

    end
    
    # set style  
    def setStyle(**properties)
      properties.each do |property, value|
        self._setStyle(property, value)
      end
      return self
    end

    def storeStyle() 

      return "" if @styles.empty?

      result = ""
      @styles.each do |key, value| 
        result += "#{key}:#{value}; "
      end

      self.set(style: result)

    end

    def setPlaceholder(placeholder, value)

      @enablePlaceholder = true
      unless (value)
        @placeholders.delete(placeholder)
        return self
      end
      @placeholders[placeholder] = value
      return self

    end

    def setSystemProperty(property, value)      
        unless (value)
          @systemProperties.delete(property)
          return self
        end
        @systemProperties[property] = value
        return self
    end

    def getSystemProperty(property)      
        return @systemProperties[property]
    end

    def setClosedTag(bool=true)
      @closeTag = bool
      return self
    end
    
    def self.test()
      widget = HWidget.new('div', "new_div")
      widget.set(title1: 't1', 
                 title2: 't2',
                 title3: 't3',
                 title4: '')
      widget.set(title2: nil)
      widget.setStyle(color: 'red')
      puts widget.openTag
      puts widget.html
      puts widget.closeTag
    end


  def self.widgetSpace()
    
    puts "###########################################################".hight_white
    puts "#                                                         #".hight_white
    puts "#                 Hypersonic Object Space                 #".hight_white
    puts "#                                                         #".hight_white
    puts "###########################################################".hight_white

    objs = []
    ObjectSpace.each_object() {|obj| objs << obj if obj.class <= HWidget }
    objs.each do |obj|
      puts "#{obj.object_id.to_s.hight_purple}: #{obj.class.to_s.yellow} - #{obj.tag.hight_cyan} #{obj.get(:class)}" 
    end
    
    #puth ObjectSpace.count_objects

    return "Total Widgets: #{objs.length}".green

  end


end

def htag(name, properties)

  return HWidget.new(name).set(properties).html()

end

def htag2(name, properties)

  return HWidget.new(name).set(properties).setClosedTag(false).html()

end


